// pages/chooseLocation/chooseLocation.js

var app = getApp()
var config = {};
var timer = null;
var miucms = require('../../utils/miucms.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isloding: true,
    alias: 0,
    hotcity: [],
    countryList: {},
    cityListLength: 0,
    cityList: [],
    letterID: '',
    countryID: 'hot',
    letter: 'A',
    scrollTop: 0,
    searchBoxHeight: 20, //搜索框高度
    screen_data: {},
    value: '',
    selectCityalias: '',
    searchList: [],
    isShowSearch: false,
    focus: false,
    searchSuggestList: [],
    isSearch: false,
    frompage: 1, //是否从世界各地房源列表点击进来
    isAuthorization: 0, //是否需要登录
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.showLoading()
    var that = this;
    this.setData({
      'frompage': options.frompage || ''
    })
    wx.getStorage({
      key: 'chooseLocationSearch',
      success: function (res) {
        that.setData({
          searchList: res.data || []
        })
      },
    })
    if (!this.data.frompage) {
      setTimeout(function () {
        that.get_config()
      }, 200)
    } else {
      this.setData({
        screen_data: app.globalData.screen_data,
        hotcity: [{
          name: '',
          id: '0',
          alias: 0
        }],
        isloding: false
      })
      wx.getStorage({
        key: 'countryList',
        success: function (res) {
          that.dataList = res.data;
          let countryList = []
          res.data.forEach(item => {
            countryList.push({
              name: item.name,
              alias: item.alias,
              weight: item.weight
            })
          })
          wx.getStorage({
            key: 'selectcityData',
            complete(_complete) {
              let index = null;
              let selectCityalias = '';
              if (_complete.data) {
                selectCityalias = _complete.data.uniqid || '';
                for (let i = 0; i < res.data.length; i++) {
                  if (res.data[i].alias == _complete.data.alias) {
                    index = i;
                    break;
                  }
                }
              }

              that.setData({
                countryList,

              }, function () {
                wx.hideLoading()
                that.calculateLetter()
                if (index !== null) {
                  that.setData({
                    alias: res.data[index].alias,
                    selectCityalias,
                    cityList: Object.assign({}, that.dataList[index].letter),
                    cityListLength: res.data[index].cityListLength,
                  })
                } else {
                  that.setData({
                    selectCityalias: 0
                  })
                }
              })

            }
          })

          wx.hideLoading()
        },
      })

    }
  },
  get_config() {
    var that = this;
    if (app.globalData.config.lists) {
      this.setData({
        screen_data: app.globalData.screen_data,
      })
      this.getList();
    } else {
      setTimeout(function () {
        that.get_config()
      }, 200)
    }
  },
  // 如果用户已经同意授权。则开始获取数据
  islogin() {
    wx.showLoading({
      title: '加载中',
    })
    this.get_config();
  },


  obvies() {
    var that = this;
    for (let i in this.data.cityList) {
      let item = this.data.cityList[i].letter;
      wx.createIntersectionObserver().relativeToViewport({
        bottom: -150
      }).observe(`#${item}`, res => {

        if (res.intersectionRatio > 0) {
          that.setData({
            letter: `${item}`
          })
        }
      })
    }

  },
  toLetter(e) {
    let {
      letter
    } = e.currentTarget.dataset;
    this.setData({
      letter,
      letterID: letter
    })

  },
  goback() {
    wx.navigateBack({

    })
  },
  dataList: [],
  // 获取地域列表
  getList() {
    let that = this;

    miucms.request(app.globalData.config.post.regions, {}).then(data => {
      if (data.code == 401) {
        wx.hideLoading()
        that.setData({
          isAuthorization: 1,
          isloding: false
        })
        return false
      }
      that.dataList = data.data.list;
      let countryList = []
      data.data.list.forEach(item => {
        countryList.push({
          name: item.name,
          alias: item.alias,
          weight: item.weight
        })
      })
      that.setData({
        hotcity: data.data.hotcity,
        countryList,
        isloding: false
      }, function () {
        wx.hideLoading()
        // that.calculateScrollHeight()
        this.calculateLetter()

      })
      wx.hideLoading()
    }).catch(res => {})
  },
  calculateScrollHeight() {
    // 获取城市列表高度
    var that = this;
    const query = wx.createSelectorQuery()
    query.select('.search-box').boundingClientRect()
    query.exec(function (res) {
      that.setData({
        searchBoxHeight: res[0].height,
        screen_data: app.globalData.screen_data
      })
    })

  },
  // 处理城市列表的letter
  calculateLetter() {
    this.dataList.forEach(item => {
      item.letter = []
      item.cityListLength = 0;
      let letter = {}
      item.city.forEach(s => {
        if (letter[s.letter]) {
          letter[s.letter].push(Object.assign({}, s))
        } else {
          letter[s.letter] = [Object.assign({}, s)]
          item.cityListLength += 1;
        }
      })
      for (let i in letter) {
        item.letter.push({
          letter: i,
          data: letter[i]
        })
      }

      item.letter.sort(function (a, b) {
        return a.letter.localeCompare(b.letter)
      })

      return item;
    })
    if (this.data.hotcity.length == 0 && this.data.alias == 0 && !this.data.frompage) {
      this.changeCountry(this.dataList[0].alias)
    }
  },
  // 点击切换国家
  changeCountry(e) {
    var alias = null,
      that = this;
    if (typeof e === "string") {
      alias = e;
    } else {
      alias = e.currentTarget.dataset.alias;
    }

    if (alias == this.data.alias) {
      return false
    } //避免重复点击
    this.setData({
      alias
    })
    if (alias != 0) {
      // 选择的是其他的国家、地区
      for (let i = 0; i < this.dataList.length; i++) {
        if (this.dataList[i].alias == alias) {

          this.setData({
            cityList: [...this.dataList[i].letter],
            cityListLength: this.dataList[i].cityListLength,
            // selectCityalias:'',
            // letter:'top',
            // scrollTop:0
          }, function () {
            that.obvies()
          })
          break;
        }
      }
    }
  },
  input(e) {
    this.setData({
      value: e.detail.value.trim(),
      // selectCityalias:'',
      isSearch: false
    })
    if (e.detail.value.trim().length >= 1) {
      this.timer = setTimeout(function () {
        this.submit()
      }.bind(this), 800)
    }

  },
  timer: null,
  // 搜索
  submit() {
    clearTimeout(this.timer)
    this.data.searchSuggestList = []
    let value = this.data.value;
    var that = this;
    this.dataList.forEach(item => {
      item.city.forEach(s => {
        if (s.name.indexOf(value) > -1 || s.alias.indexOf(value) > -1) {
          s['countryName'] = item.name;
          that.data.searchSuggestList.push(s)
        }
      })
    })
    this.setData({
      searchSuggestList: this.data.searchSuggestList,
      isSearch: true
    })
  },
  // 找到搜索记录关键词
  findKeyWord(obj, alias) {
    this.changeCountry(alias)
    this.data.searchList.push(Object.assign({}, obj))
    if (this.data.searchList.length > 3) {
      this.data.searchList.length = 3
    } //最多保留3个搜索记录
    this.setData({
      countryID: alias,
      searchList: this.data.searchList,
      letterID: obj.letter,
      // selectCityalias: obj.alias
    }, function () {
      this.calculateScrollHeight()
    })
    wx.setStorage({
      key: 'chooseLocationSearch',
      data: this.data.searchList,
    })

  },
  // 选择城市
  selectCity(e) {
    let {
      name,
      alias,
      search,
      uniqid
    } = e.currentTarget.dataset;
    let that = this;
    if (search) {
      let isinsearchList = false;
      this.data.searchList.every(item => {
        if (item.name === name) {
          isinsearchList = true;
          return false
        }
        return true;
      })
      if (!isinsearchList) {
        // 如果是用户自己输入的点击，则需记录到历史数据
        this.data.searchList.push({
          name,
          alias,
          uniqid
        })
        if (this.data.searchList.length > 3) {
          this.data.searchList.length = 3
        } //最多保留3个搜索记录
        this.setData({
          searchList: this.data.searchList
        })
        wx.setStorage({
          key: 'chooseLocationSearch',
          data: this.data.searchList,
        })
      }
    }
    if (this.data.frompage == 1) {

      wx.setStorage({
        key: 'selectcityData',
        data: {
          uniqid,
          name,
          alias: that.data.alias
        },
      })
      wx.navigateBack()
    } else {
      wx.navigateTo({
        url: `/pages/edit/edit?cityName=${name}&alias=${alias}&uniqid=${uniqid}`,
      })
    }

  },
  // 清除关键词
  clearKW() {
    this.setData({
      value: '',
      focus: true
    })
  },
  // 清空搜索记录
  clearHistory() {
    this.setData({
      searchList: []
    })
    wx.setStorage({
      key: 'chooseLocationSearch',
      data: [],
    })
  },
  // input获取焦点
  toSearch() {
    this.data.isShowSearch = !this.data.isShowSearch;
    this.setData({
      isShowSearch: this.data.isShowSearch,
      focus: this.data.isShowSearch,
      searchSuggestList: [],
      value: ''
    })
  },
  // 点击添加城市按钮
  addCity() {
    let myComponent = this.selectComponent('#addCityComponent');
    myComponent.showPage();
  },
  back() {
    this.setData({
      isShowSearch: false
    })
  }
})