// pages/show/show.js
var app = getApp()
var miucms = require('../../utils/miucms.js');
var config = {};
var WxParse = require('../../wxParse/wxParse.js');
var screenWidth = 288;
var center_position = 144;
var avatar_height = 40;
var screenWidth2 = 288;
var center_position2 = 144;
var save = false;
var today = new Date();
var time_now = today.getFullYear() + '.' + (today.getMonth() > 8 ? (today.getMonth() + 1) : '0' + (today.getMonth() + 1)) + '.' + (today.getDate() > 9 ? today.getDate() : '0' + today.getDate());
var windowWidth = 0;
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isloding: true,
    showTOTOP: false,
    tid: '',
    uniqid: '0W4XS5SrvSHD',
    token: '',
    imgUrls: [],
    page: {
      next_page: 1
    },
    data: [],
    contact: {},
    loading: false,
    info: {
      subject: '寄托香港租房-学生公寓'
    },
    listTab: {},
    brands: {
      list: [],
      value: '',
      obj: {}
    },
    roomlistings: {
      list: [],
      value: '',
      obj: {}
    },
    roomtype: {
      list: [],
      value: '',
      obj: {}
    },
    money: {
      rent_min: 0,
      rent_max: ''
    },
    screen_data: {},
    schoolList: [],
    school: '',
    schoolObj: {},
    irenCouponReceive: null,
    irentCouponBig: true,
    hideCoupon: false,
    initState: false
  },
  onPageScroll(e) {
    if (e.scrollTop > 1000 && !this.data.showTOTOP) {
      this.setData({
        showTOTOP: true
      })
    } else if (e.scrollTop < 1000 && this.data.showTOTOP) {
      this.setData({
        showTOTOP: false
      })
    }
    clearTimeout(this.timer)
    if (!this.data.irentCouponBig && this.data.irenCouponReceive) {
      //   显示在侧边栏
      this.setData({
        hideCoupon: true
      })
    }
    this.timer = setTimeout(() => {
      this.setData({
        hideCoupon: false
      })
    }, 3000)
  },
  timer: null,
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.showLoading()

    wx.getSystemInfo({
      success: function (res) {
        windowWidth = res.windowWidth
      }
    })
    this.data.roomtype.value = options.roomtype || '';
    this.data.roomlistings.value = options.roomlistings || '';
    this.data.brands.value = options.brands || '';
    if (options.money) {
      let money = options.money.split('~')
      this.data.money.rent_min = money[0];
      this.data.money.rent_max = money[1];
    }
    this.setData({
      irentCouponBig: app.globalData.irentCouponBig,
      options: options || {},
      school: options.school || '',
      roomlistings: this.data.roomlistings,
      roomtype: this.data.roomtype,
      money: this.data.money,
      brands: this.data.brands
    })
    screenWidth = wx.getSystemInfoSync().screenWidth;
    center_position = screenWidth / 2;
    this.setData({
      screenWidth: screenWidth,
    })
    this.attachedIn()
    this.get_config()
  },
  attachedIn() {
    if (app.globalData.screen_data.totalTopHeight > 30) {
      this.data.screen_data = app.globalData.screen_data;
      this.setData({
        screen_data: app.globalData.screen_data
      })
    } else {
      try {
        app.computeNavigateBarHeight();
      } catch (e) {
        // 获取系统信息失败
        this.setData({
          screen_data: {
            windowHeight: 812,
            totalTopHeight: 68,
            statusBarHeight: 20,
            titleBarHeight: 48,
            titleWidth: 87
          },
        });
      }
    }

  },
  get_config() {
    var that = this;
    if (app.globalData.config.lists) {
      config = app.globalData.config;
      that.setData({
        user: app.globalData.user,
        status: app.globalData.status,
        listTab: app.globalData.listTab,
        initState: true
      })
      this.getfilterConditions();
      this.getList()
      this.get_content();

    } else {
      setTimeout(function () {
        that.get_config()
      }, 200)
    }
  },


  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.setData({
      page: {
        next_page: 1
      },
      data: []
    })
    this.getList()
    wx.stopPullDownRefresh();
  },
  onReachBottom() {
    // 加载下一页
    if (!this.data.page.next_page) {
      return false
    }
    this.getList()
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {

    if (res.from === 'button') {
      // 来自页面内转发按钮
      console.log(res.target)
      var types = res.from === 'button' ? 'share_btn' : 'show';
    }
    let that = this;
    let path = `/pages/irentList/irentList?school=${this.data.school}&brands=${this.data.brands.value}&roomtype=${this.data.roomtype.value}&roomlistings=${this.data.roomlistings.value}&money=${this.data.money.rent_min}~${this.data.money.rent_max}`;
    let title = this.data.school ? `寄托香港租房-${this.data.schoolObj[this.data.school]}附近公寓` : that.data.info.subject;
    return {
      title,
      imageUrl: that.data.info.share_img,
      path,
      success: function (res) {
        miucms.share(app, types)
      },
      fail: function (res) {
        // 转发失败
      }
    }

  },
  // 获取筛选条件
  getfilterConditions() {
    let that = this;
    var sendData = Object.assign({}, this.data.options, {
      session: wx.getStorageSync('session'),

    })
    miucms.request(app.globalData.config.studentapartment.filterConditions, {}).then(data => {
      wx.hideLoading()
      // console.log(data)
      if (data.extraparam) {
        wx.showModal({
          title: '提示',
          content: data.message,
        })
      } else {
        data.data.brand.forEach(item => {
          item.value = item.id;
          that.data.brands.obj[item.id] = item.name;
        })
        that.data.brands.list = [{
          value: '',
          name: '全部品牌'
        }, ...data.data.brand];

        data.data.roomtype.forEach(item => {
          item.value = item.id;
          that.data.roomtype.obj[item.id] = item.name;
        })
        that.data.roomtype.list = [{
          value: '',
          name: '全部房型'
        }, ...data.data.roomtype];


        data.data.roomlistings.forEach(item => {
          item.value = item.id;
          that.data.roomlistings.obj[item.id] = item.name;
        })
        that.data.roomlistings.list = [{
          value: '',
          name: '全部楼型'
        }, ...data.data.roomlistings];


        let schoolObj = {}
        data.data.school.forEach(item => {
          schoolObj[item.id] = item.name
        })

        that.setData({
          schoolObj,
          schoolList: data.data.school,
          brands: that.data.brands,
          roomtype: that.data.roomtype,
          roomlistings: that.data.roomlistings
        })

      }
    }).catch(res => {})
  },
  get_content: function () {
    let that = this;
    var sendData = Object.assign({}, this.data.options, {
      session: wx.getStorageSync('session'),
    })
    miucms.request(app.globalData.config.studentapartment.slide, {}).then(data => {
      wx.hideLoading()
      if (data.extraparam) {
        wx.showModal({
          title: '提示',
          content: data.message,
        })
      } else {
        that.setData({
          imgUrls: data.data
        })
      }
    }).catch(res => {})

  },
  // 获取列表
  getList: function () {
    let that = this;
    if (this.data.page.next_page === 0) {
      return false
    }
    if (this.data.loading) {
      return false
    }
    this.setData({
      loading: true
    })

    miucms.request(app.globalData.config.studentapartment.lists, {
      page: this.data.page.next_page,
      school: this.data.school,
      brand: this.data.brands.value,
      roomlistings: this.data.roomlistings.value,
      roomtype: this.data.roomtype.value,
      rent_min: this.data.money.rent_min,
      rent_max: this.data.money.rent_max
    }).then(data => {
      if (data.extraparam) {
        wx.showModal({
          title: '提示',
          content: data.message,
        })
      } else {
        that.data.data = that.data.data.concat(data.data),
          that.setData({
            data: that.data.data,
            // data: that.data.data.concat(data.data),
            page: data.page,
            contact: data.contact,
            loading: false,
            irenCouponReceive: data.irenCouponReceive
          })
      }
      wx.hideLoading()

    }).catch(res => {})


  },
  copy(e) {
    const content = e.currentTarget.dataset.content;
    miucms.copy(content).then((res) => {
      console.log('res', res)
    }).catch(err => {
      console.log(err)
    })

  },
  // 租金条件筛选提交
  submitMoney(e) {
    this.data.money = Object.assign({}, e.detail);
    this.setData({
      selectGroupIndex: null,
      money: this.data.money
    })
    this.clear_data()
  },
  // 选择品牌
  submitBrands(e) {
    this.data.brands.value = e.detail.value;
    this.setData({
      brands: this.data.brands
    })
    this.clear_data()
  },
  // 选择房型
  submitRoomtype(e) {
    this.data.roomtype.value = e.detail.value;
    this.setData({
      roomtype: this.data.roomtype
    })
    this.clear_data()
  },
  // 选择楼型
  submitRoomlistings(e) {
    this.data.roomlistings.value = e.detail.value;
    this.setData({
      roomlistings: this.data.roomlistings
    })
    this.clear_data()
  },
  clear_data() {
    this.setData({
      page: {
        next_page: 1
      },
      data: []
    })
    wx.pageScrollTo({
      scrollTop: 0,
      duration: 200,
    })
    this.getList()
  },
  // 点击选择学校
  chooseSchool(e) {
    this.setData({
      school: e.currentTarget.dataset.id
    })
    this.clear_data()
  },
  // 前往对方小程序
  tominiProgram(e) {
    let {
      path,
      appId
    } = this.data.irenCouponReceive;
    let that = this;
    wx.navigateToMiniProgram({
      appId,
      path,

      success(res) {
        // 打开成功
        // console.log('打开成功')
      },
      complete(res) {
        // console.log('complete',res)
        let isOpen = res.errMsg == 'navigateToMiniProgram:ok' ? true : false;
        that.stat(isOpen)
      }
    })
  },
  // 统计点击
  stat(isOpen) {
    if (this.data.irenCouponReceive.stat === null) {
      return false
    }
    miucms.request(app.globalData.config.studentapartment.stat, {
      stat: this.data.irenCouponReceive.stat,
      isOpen
    }).then(res => {

    }).catch(res => {})
  },
  // 放大，缩小现金券
  showIrentCoupon() {
    this.setData({
      irentCouponBig: !this.data.irentCouponBig,
      hideCoupon: false
    })
    if (!this.data.irentCouponBig) {
      app.globalData.irentCouponBig = false;
    }
  },
})