// template/goLogin/goLogin.js
var app = getApp();
var miucms = require('../../utils/miucms.js');
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据
   */
  data: {
    status: 0,
    timer: null,
    isUserAuthorization: 1, //用户点击授权:0：未知，1：未授权，2：已授权
    canIUseGetUserProfile: false
  },

  /**
   * 组件的方法列表
   */
  lifetimes: {
    attached: function () {
      this.attachedIn()
    },
  },
  attached: function () {
    this.attachedIn()
  },
  methods: {
    // 跳转offer榜小程序
    gooffer() {
      wx.openEmbeddedMiniProgram({
        appId: "wxa9296b07391c2bc7",
        path: "/pages/victoryDetails/victoryDetails?id=LbKPvjODun5K",
        envVersion: 'trial',
        extraData: {
          // 把1368数字换成你的产品ID，否则会跳到别的产品
          id: "451478",
          // 自定义参数，具体参考文档
          customData: {},

          fail: (error) => {
            console.log('跳转小程序失败', error)
          },
        }
      })
      // wx.openEmbeddedMiniProgram({
      //   // 要跳转的小程序的appid
      //   appId: 'wxa9296b07391c2bc7',
      //   envVersion:  'release',
      //   path: `/pages/victoryDetails/victoryDetails?id=LbKPvjODun5K`,
      //   success: () => {},
      //   fail: (error) => {
      //     console.log('跳转小程序失败', error)
      //   },
      //   complete: () => {
      //     wx.hideLoading()
      //   }
      // })
    },
    attachedIn() {
      let that = this;
      this.setData({
        canIUseGetUserProfile: app.globalData.canIUseGetUserProfile
      })
      // this.getAuthorization()

    },
    getAuthorization() {
      let that = this;
      if (app.globalData.isUserAuthorization == 1) {
        // 用户未授权----弹窗
        this.setData({
          isUserAuthorization: 1
        })
      } else if (app.globalData.isUserAuthorization == 2) {
        // 用户已授权---隐藏
        setTimeout(function () {
          this.triggerEvent('islogin', {
            ispageinlogin: true
          })
        }.bind(this), 100)

      } else {
        // 还未知是否用户授权
        setTimeout(function () {
          that.getAuthorization()
        }, 100)
      }
    },
    onGotUserInfo: function (e) {
      if (this.data.canIUseGetUserProfile) {
        wx.getUserProfile({
          desc: '用于完善会员资料', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
          success: (res1) => {
            console.log('getUserProfile', res1);
            this.toAuthorization(res1)
            app.globalData.user = res1.userInfo;
          }
        })
        return false;
      }
      if (e.detail.errMsg == 'getUserInfo:ok') {
        //用户同意授权
        this.toAuthorization(e.detail)
        console.log(e)
        app.globalData.user = e.detail.userInfo;
      }
    },
    toAuthorization(detail) {
      var that = this;
      var url = app.globalData.config.user ? app.globalData.config.user.authorization : 'https://app.gter.net/tenement/user/authorization';
      wx.login({

        success: function (res) {
          miucms.request(url, Object.assign(detail, {
            code: res.code
          })).then(data => {
            if (data.extraparam && data.extraparam.mode == 'right') {
              // 注册成功
              console.log('success    ', data.data.session)
              wx.setStorageSync('Authorization', data.data.session)
              app.globalData.isUserAuthorization = 2;
              app.globalData.header['Authorization'] = data.data.session;
              app.globalData.user = data.data;
              that.triggerEvent('islogin', {
                ispageinlogin: false
              })
              that.setData({
                isUserAuthorization: 2
              })
              app.globalData['announcementPopupData'] = []
              app.globalData['alreadyAnnouncementPopupWindowList'] = []
              that.triggerEvent('authorizationSuccess')
            }
            if (data.code == 201) {
              wx.showToast({
                icon: "none",
                title: '授权失败',
              })
            }
          })
        },

      });

    }
  }
})