// template/headerNav/index.js
var app = getApp()
Component({
  options: {
    multipleSlots: true
  },
  /**
   * 组件的属性列表
   */
  properties: {
    notShowIndex: Boolean,
    isIndexPage: Boolean,
    haveSearch: Boolean,
    customBack: Boolean,
    isMessageCount: Boolean,
    unreadMessages: Number,
    isMessage: Boolean,
    bgcolor: String,
    position: String, // css 定位方式
  },

  /**
   * 组件的初始数据
   */
  data: {
    // templateHeader:'templateHeadersss',
    screen_data: {
      windowHeight: 0,
      totalTopHeight: 0,
      statusBarHeight: 0,
      titleBarHeight: 0,
    },
    // isIndexPage:false,
    isTabPage: false
  },
  lifetimes: {
    attached: function () {
      this.attachedIn()
    },
  },
  attached: function () {
    this.attachedIn()
  },

  /**
   * 组件的方法列表
   */
  methods: {
    attachedIn() {
      if (app.globalData.screen_data.totalTopHeight > 30) {
        this.data.screen_data = app.globalData.screen_data;
        this.data.screen_data.index = false;
        this.setData({
          screen_data: app.globalData.screen_data
        })
      } else {
        try {
          app.computeNavigateBarHeight();
        } catch (e) {
          // 获取系统信息失败
          this.setData({
            windowHeight: 812,
            totalTopHeight: 68,
            statusBarHeight: 20,
            titleBarHeight: 48,
            titleWidth: 87
          });
        }
      }

    },
    backHome() {
      wx.reLaunch({
        url: `/pages/index/index`,
      })
    },
    navigategoBack() {
      var pages = getCurrentPages();
      if (this.properties.customBack) {
        this.triggerEvent('back', {}, {})
        return false;
      }
      if (pages.length == 1) {
        wx.reLaunch({
          url: `/pages/index/index`
        });
      } else {
        wx.navigateBack({
          changed: true
        }); //返回上一页
      }
    },
    // 跳转消息页面
    goMessageCenter() {
      this.triggerEvent('unreadMessagesalter')
    },

    // 跳转发布系统消息页面
    goIsMessage() {
      this.triggerEvent("goIsMessage")
    }
  }
})